<style type="text/css">
.wpformel * {
	box-sizing:border-box;
	font-family:'Liberation Serif','Times New Roman',Serif;
	white-space:nowrap; }
.wpformel.formel {
	display:inline-block;
	vertical-align:middle; }	
.wpformel.neben {	
	vertical-align:top; 
	display:inline-block;
	text-align:left; }
.wpformel.unten {
	vertical-align:top; 
	display:block;
	text-align:center; }
</style> 

<?php
/*
Editor zum Erstellen von mathematischen Formel in HTML
Autor: Wolfgang Pavel
Internet: www.wpavel.de
Copyright: Darf nur kostenfrei - zusammen mit diesem Autorenhinweis -
           weitergegeben werden.
Letzte Korrektur: 28.12.2014
*/

/// Konfiguration ////////////////////////////////////

// Syntaxrelevante Konfigurationen:

define("Operator","* · : = ~ ∼ < > ∧ ∨ ∈ ∉ ∋ ∗ ∝ ≅ ≈ ≡ ⊂ ⊃ ⊄ ⊆ ⊇ ⊕ ⊗ ⊥ ⋅ ← ↑ → ↓ ↔ ↵ ⇐ ⇑ ⇒ ⇓ ⇔ • ≤ ≥ ≠");
define("Unaer","+ - − ± ¬ ∠"); // automatisch auch in Operator
define("Mehrfach","+-,± <=,≤ =<,≤ >=,≥ =>,≥ <>,≠ ->,→ <-,← <->,↔");
define("Klammer","{,},0 [,],2 (,),2 〈,〉,2 |,|,2"); // auf,zu,Anpassung
define("Funktion","ln log exp ".
                  "sin cos tan tg cot ctg ".
                  "arcsin asin arccos acos arctan atan arccot acot ".
                  "sinh cosh tanh coth arsinh arcosh artanh arcoth");
define("Anpasser","√,2 §,2 ∫,3 ∑,3 ∏,3"); // Zeichen,Defaultanpassung
define("Griechisch","ABGDEZIQJKLMNXOPR STYFCVW");

// Größenrelevante Konfigurationen:

define("KfgZmt",3.5/16);  // oberer Bereich nur von Spezialsymbolen belegt
define("KfgZmo",4/16);    // oberer Bereich für Großbuchstaben (Oberlängen)
define("KfgZmm",7.5/16);  // mittlerer Bereich (Kleinbuchstaben)
define("KfgZmu",3.5/16);  // Unterlängenbereich
define("KfgZmn",KfgZmo+KfgZmm);        // Zeichengröße normale Zeichen (11.5/10)
define("KfgZgh",KfgZmt+KfgZmn+KfgZmu); // Zeichengesamthöhe (18.5/16)

define("KfgZbr",8/16);    // Schriftzeichenbreite
define("KfgZwr",2.5/16);  // Formelzwischenraumbreite in em
define("KfgOab",1);       // Anzahl, nicht em! :
                          // Mindestabstand vor und nach Operatoren
define("KfgVop",0.12);    // evtl. vertikale Verschiebung bei Operatoren
define("KfgBst",0.75/16); // Bruchstrichdicke
define("KfgVpd",2.5/16);  // Padding in Zellen
define("KfgBsf",12/16);   // Schriftgrößenfaktor in Brüchen
define("KfgHsf",12/16);   // Schriftgrößenfaktor für Hoch- und Tiefgestelltes
define("KfgKsf",18/16);   // Schriftgrößenfaktor für Klammern und Anpasser (>1)
define("KfgWgf",8/16);    // Schriftgrößenfaktor für Wurzelgrad
define("KfgWpv",-4/16);   // Padding des Wurzelgrads vertikal
define("KfgWph",8/16);   // -Padding horizontal des Wurzelgrads
define("KfgWst",0.75/16); // Strichdicke für Wurzelzeichen
define("KfgWsp",1.5/16);  // Padding unter Wurzelstrich
define("KfgGsf",12/16);   // Schriftgrößenfaktor für Grenzen
                          //    (Obenunten:Summe,Integral,Produkt)
define("KfgSgp",20);      // Wert ab dem Schriftgrößen als Prozent genommen werden                        

define("Zeichen_klein",  // belegen nur Kernbereich
       ". a c e m n o r s u v w x z α ε ι κ ν ο π τ υ ω ϖ ∞ – — ".
       "* · = ~ ∝ ≈ ⋅ ↵ • + - − ≠");
define("Zeichen_unter",  // belegen Kernbereich und Unterlänge
       ", ; g p q y _ γ η μ ρ ς φ χ ψ");
define("Zeichen_weit", // belegen Kernbereich, Unterlänge und Oberlänge
       "j f @ | 〈 〉 β ζ ξ ƒ");
define("Zeichen_einzeln", // Zeichen,über Grundlinie, unter Grundlinie
       "(,)~".(KfgZmn+1/16)."~".(KfgZmu-1/16)." [,]~".(KfgZmn+1/16)."~".(1.75/16)." {,}~".(KfgZmn+0.5/16)."~".(1.5/16)." ".
       "√,§~".(KfgZmn+2/16)."~".(KfgZmu-4.5/16)." ∫~".KfgZmn."~".(KfgZmu-1/16)." ∑,∏~".(KfgZmn-0.5/16)."~".(KfgZmu-1/16));
// alle anderen belegen Kernbereich und Oberlänge

/////////////////////////////////////////////////////////

$WPF_EIGENSCHAFTEN=Null;
function wpeigenschaften($eig="") {
global $WPF_EIGENSCHAFTEN,$WPF_EIG;
   $et=array("sn","sf","hf","sg","ms");
   $WPF_EIG=array();
   if($WPF_EIGENSCHAFTEN&&is_string($WPF_EIGENSCHAFTEN)) 
      $eg=explode(";",$WPF_EIGENSCHAFTEN); else $eg=array();
   if($eig&&is_string($eig)) $ei=explode(";",$eig); else $ei=array();
   $ez=array_merge($eg,$ei);
   foreach($ez as $e) {
      if(trim($e)=="") continue;
      $s=explode(":",$e);
      if(count($s)!=2) continue;
      $a=trim($s[0]); if(!in_array($a,$et)) continue;
      $w=trim($s[1]); if(!is_string($w)) continue;
   	if($a=="sg"||$a=="ms") { // Schriftgröße oder miminale Schriftgröße   
			$p=false; $f=1; 
			if(mb_substr($w,mb_strlen($w)-1,1)=="%") {
				$w=mb_substr($w,0,strlen($w)-1); $p=true; }
			if(!is_numeric($w)) continue; 
			if($p) $w=$w/100;
				elseif($w>KfgSgp) $w=$w/100; // aus Kompatibilitätsgründen: zahl>KfgSgp automatisch als %
			if(($a=="sg"&&$w==1)||($a=="ms"&&$w>1)) continue; }
	   $WPF_EIG[$a]=$w; }}

////////////////////////////////////////////////////////////////////////////

function teile($k) {
   $a=explode(" ",$k); $b=array();
   foreach($a as $e) { $e=trim($e); if($e) $b[]=$e; }
   return $b; }

function klasse($g) {
   if(!$g) return "";
   if(!is_object($g)) return "";
   return get_class($g); }

$Operator=teile(Operator);

$Unaer=teile(Unaer); $k=$Unaer;
foreach($Unaer as $y) {
   if(!in_array($y,$Operator)) $Operator[]=$y; }
   
$Mehrfach=array(); $k=teile(Mehrfach);
foreach($k as $y) {
   $x=explode(",",$y);
   if(count($x)==2) {
      $z=trim($x[1]);
      $Mehrfach[trim($x[0])]=$z; }}

$Klammer=array(); $Klammerzu=array(); $k=teile(Klammer);
foreach($k as $y) {
   $x=explode(",",$y);
   if(count($x)==3) {
      $Klammer[trim($x[0])]=array();
      $Klammer[trim($x[0])]["zu"]=trim($x[1]); $Klammerzu[]=trim($x[1]);
      $ap=trim($x[2]); if($ap!=="") $ap=intval($ap); else $ap=1;
      $Klammer[trim($x[0])]["ap"]=$ap; }}

$Funktion=teile(Funktion);

$Anpasser=array(); $k=teile(Anpasser);
foreach($k as $a) {
   $e=explode(",",$a);
   $Anpasser[trim($e[0])]=trim($e[1]); }

$SzMasse=array();
// o=von Grundlinie bis Oberkante
// u=von Grundlinie bis Unterkante
$SzMasse[""]=array("o"=>KfgZmn/2,"u"=>KfgZmn/2);  // für alle sonstigen, h=KfgZmn
foreach(teile(Zeichen_weit)as $z) 
   $SzMasse[$z]=array("o"=>KfgZmn/2,"u"=>KfgZmu+KfgZmn/2); // h=KfgZmn+KfgZmu
foreach(teile(Zeichen_klein)as $z)
   $SzMasse[$z]=array("o"=>KfgZmm-KfgZmn/2,"u"=>KfgZmn/2); // h=KfgZmm
foreach(teile(Zeichen_unter)as $z) 
	$SzMasse[$z]=array("o"=>KfgZmm-KfgZmn/2,"u"=>KfgZmu+KfgZmn/2); // H=KfgZmm+KfgZmu
foreach(teile(Zeichen_einzeln)as $z) {
   $e=explode("~",$z);
   $f=explode(",",$e[0]);
   foreach($f as $y) {
   	$SzMasse[$y]=array("o"=>trim($e[1])-KfgZmn/2,"u"=>trim($e[2])+KfgZmn/2); }}

/// Makros /////////////////////////////////////////////////////////////////

function mkintegral($p) {
   return "∫".(is_string($p[1])?"__{".$p[1]."}":"").
                  (is_string($p[2])?"^^{".$p[2]."}":"").
                  "{".$p[0]."}"; }

function mkwurzel($p) {
   if(is_string($p[1])) {
      if(mb_strlen($p[1])==1) $g=$p[1]; else $g="{".$p[1]."}"; }
   else $g="";
   return $g."§{".$p[0]."}"; }

////////////////////////////////////////////////////////////////////////////

function schriftcheck($s,$f) { // wird bei Schriftgrößen-Änderung aufgerufen
	// s=übergeordnete Schriftgröße, f=Faktor; Rückkehr: (neuer) Faktor
	global $WPF_EIG;
	if(array_key_exists("ms",$WPF_EIG)&&$f*$s<abs($WPF_EIG["ms"])) { // Schrift kleiner als Minimum
		if($WPF_EIG["ms"]<0) return $WPF_EIG["ms"]/($s*$f); // Formel um diesen Faktor vergrößern (<0)
		if($WPF_EIG["ms"]>0) $f=$WPF_EIG["ms"]/$s; } // Schrift nicht unter Minimum verkleinern (>0)
   return $f; }
    
function zeige($fb,$zx="") {
	echo "<div style='margin-left:1em'>\n".
		($zx?$zx.": ":"").
      klasse($fb)." ::: ".
      "h=".round($fb->hoehe,3)." | ".
      "oh=".round($fb->ohoehe,3)." | ".
      "uh=".round($fb->uhoehe,3)." | ".
      "b=".round($fb->breite,3)." | ".
      " ::: ";
 	$fb->zeige();
  	echo "</div>\n"; }

function title($t) {
	global $WPF_EIG;
	if(array_key_exists("tt",$WPF_EIG)&&$WPF_EIG["tt"]) return " title='".$t."'";
		else return ""; }

class cl_vorlage {
   public $uhoehe=0,$ohoehe=0,$breite=0,$anpass=Null,$wert=Null,$titel="",$efarbe="";
   public function __construct($w) {}
   public function __get($hoehe) { return $this->uhoehe+$this->ohoehe; }
   public function mass($fs) { }
   public function nblock($t="",$pv=0,$fs=1,$s="") { $this->block("neben",$t,$pv,$fs,$s); }    
	public function ublock($t="",$pv=0,$fs=1,$s="") { $this->block("unten",$t,$pv,$fs,$s); }
	public function block($nu="neben",$t="",$pv=0,$fs=1,$s="") {
		echo "<div".title($t).
		   " class='wpformel ".$nu."'".
		   " style='height:".($this->height)."em;". 
	         ($fs<>1?"font-size:".$fs."em;":"").	   
		   	($pv?"padding-top:".($pv/$fs)."em;":""). // Vorschub äußerer Faktor
		   	($s?$s:"")."'>\n"; }	  	
   public function ausgabe() {} 
   public function zeige() {}}

class cl_zeichen extends cl_vorlage {
   public $wert;
   public function __construct($w,$t="Zeichen") {
      $this->wert=$w; $this->titel=$t; }
	public function mass($fs) {  	
   global $SzMasse;
 		$w=$this->wert; 
      if($w==="") { $this->ohoehe=0; $this->uhoehe=0; $this->breite=0; }
      else {
         if(array_key_exists($w,$SzMasse)) $bu=$SzMasse[$w];
            else $bu=$SzMasse[""];
      	$this->ohoehe=$bu["o"]; $this->uhoehe=$bu["u"];
      	$this->breite=KfgZbr; }}
   public function ausgabe() {
   	$w=$this->wert; $zs="";	
      if($w==="") return;
		if(klasse($this)=="cl_operator") {
      	$a=$this->zwanf*KfgZwr; $e=$this->zwend*KfgZwr;
         $zs=($a?"padding-left:".$a."em;":"").($e?"padding-right:".$e."em":""); }
      $this->nblock($this->titel,0,1,
			"margin-top:".($this->ohoehe-KfgZmt-KfgZmn/2)."em".
			($zs?";".$zs:"")); 
      echo ($w==" "?"&nbsp;":$w); 
      echo "</div>"; }
   public function zeige() {
      echo $this->wert; }}

class cl_zeichenfolge extends cl_zeichen {
	private $tx;
   public function __construct($w,$t="Zeichenfolge",$tx=false) {
      // tx= ist Text
      parent::__construct($w,$t);
      $this->tx=$tx; }
   public function mass($fs) {   
   global $SzMasse;
      $u=0; $o=0; $zanz=0; $w=$this->wert;
      for($b=0;$b<mb_strlen($w);$b++) {
         $y=mb_substr($w,$b,1); $p=false;
         if($y=="&") { // nicht für - bereits UTF-codierte - gültige HTML-entities 
            $p=strpos($w,";",$b+1);
            if($p!==false) { $y=substr($w,$b,$p-$b+1); $b=$p; }}
         if(array_key_exists($y,$SzMasse))
            $bu=$SzMasse[$y]; else $bu=$SzMasse[""];
         if($bu["o"]>$o) $o=$bu["o"]; if($bu["u"]>$u) $u=$bu["u"]; 
         $zanz++; }
      $this->ohoehe=$o; $this->uhoehe=$u;
      $this->breite=$zanz*KfgZbr; }
	public function ausgabe() {
		$w=$this->wert; $x=""; $i=false; 
      if(!$this->tx) $w=str_replace(" ","&nbsp;",$w);
      for($b=0;$b<mb_strlen($w);$b++) {
         $y=mb_substr($w,$b,1); $p=false;
         if($y=="&") { 
            $p=mb_strpos($w,";",$b+1);
            if($p!==false) { $y=mb_substr($w,$b,$p-$b+1); $b=$p; }}
         if($p===false&&(($y>="a"&&$y<="z")||($y>="A"&&$y<="Z"))) {
            if(!$i&&!$this->tx) { $x.="<i>"; $i=true; }}
         else {
            if($i) { $x.="</i>"; $i=false; }}
         $x.=$y; }
      if($i) $x.="</i> "; // Zwischenraum wegen IE
      $this->wert=$x; parent::ausgabe(); }}

class cl_text extends cl_zeichenfolge {
   private $anfzeichen;
   public function __construct($w,$af="") {
      parent::__construct($w,"Text",true);
      $this->anfzeichen=$af; }
   public function zeige() {
      echo $this->anfzeichen.$this->wert.$this->anfzeichen; }}

class cl_zwraum extends cl_vorlage {
   public $anzahl;
   public function __construct($a) {
      $this->anzahl=$a; }
   public function mass($fs) { 
      $this->breite=$this->anzahl*KfgZbr*KfgZwr;
      $this->ohoehe=0; $this->uhoehe=0; }
   public function ausgabe() {
      echo "<span ".title("zwraum").
           "style='padding-left:".($this->anzahl*KfgZwr)."em;".
           "line-height:0;height:0;'>".
           "<span style='font-size:0em;'>&nbsp;</span></span>\n"; }
   public function zeige() {
      echo str_repeat("•",$this->anzahl); }}

class cl_funktion extends cl_zeichenfolge {
   public function __construct($w) {
      parent::__construct($w,"Funktion",true); }}

class cl_operator extends cl_zeichen {
   public $zwanf,$zwend; private $uoh=Null;
   public function __construct($w,$zwa=0,$zwe=0) {
      if($w=="-") $w="−";
      elseif($w=="*") $w="·";
      elseif($w[0]!="&") $w=htmlspecialchars($w,null,"UTF-8");
      $this->zwanf=$zwa; $this->zwend=$zwe;
      parent::__construct($w,"Operator"); }
   public function mass($fs) { 
   	parent::mass($fs);
      if($this->zwanf<KfgOab) $this->zwanf=KfgOab;
      if($this->zwend<KfgOab) $this->zwend=KfgOab;
      $this->breite=KfgZbr+($this->zwanf+$this->zwend)*KfgZwr; }
   public function zeige() {
      echo str_repeat("•",$this->zwanf).$this->wert.
           str_repeat("•",$this->zwend); }}

class cl_apzeichen extends cl_zeichen {
   public $anpassung;
   function __construct($w,$ap) {
   global $Anpasser,$Klammer,$Klammerzu,$Operator;
      if($w==" ") $w="";
      $this->anpassung=$ap;
      if(in_array($w,$Operator)) { // Anpassoperator wie Standard
         $this->wert=$w; $this->breite=KfgZbr;
         $this->ohoehe=KfgZmn/2; $this->uhoehe=KfgZmn/2; }
      else parent::__construct($w); }}

class cl_eigentag extends cl_vorlage {
   public $eigenschaft;
   function __construct($w,$e) {
      $this->wert=$w;
      $this->eigenschaft=$e; }}

class cl_fehler extends cl_zeichenfolge {
   public function __construct($x="?") {
      parent::__construct(htmlentities($x),"Fehler",true); }
   public function ausgabe() {
      echo "<div class='wpformel neben' style='color:red;font-weight:bold'>";
      parent::ausgabe();
      echo " </div>"; }}

class cl_tief extends cl_vorlage {
   public $basis,$index; private $is,$vp;
   public function __construct($b,$t,$ef="") {
      if($b!==Null) $this->basis=$b; else $this->basis=new cl_fehler();
      if($t!==Null) $this->index=$t; else $this->index=new cl_fehler(); 
      $this->efarbe=$ef; }
   public function mass($fs,$os=Null) {
      if(($m=$this->basis->mass($fs))<0) return $m;
      if($os===Null) $f=1; else $f=$os/$fs;
      $this->is=schriftcheck($fs,$f*KfgHsf);
      if($this->is<0) return $this->is; // Formel noch einmal größer erstellen
      if(($m=$this->index->mass($fs*$this->is))<0) return $m;
      $ih=$this->is*$this->index->hoehe;
      if($this->basis->hoehe>$ih) $this->vp=$ih/2;
         else $this->vp=$ih-$this->basis->hoehe/2;
      $this->ohoehe=$this->basis->ohoehe;
      $this->uhoehe=$this->basis->uhoehe+$this->vp;
      $this->breite=$this->basis->breite+$this->is*$this->index->breite; }
   public function ausgabe($ef="") {
   	$this->basis->nblock("Tiefbasis");
		$this->basis->ausgabe($ef);      
      echo "</div>";
      $this->index->nblock("Tiefindex",$this->hoehe-$this->is*$this->index->hoehe,$this->is);
		$this->index->ausgabe($ef);      
      echo "</div>"; }
   public function zeige() {
      zeige($this->basis,"Basis"); zeige($this->index,"Tief"); }}

class cl_hoch extends cl_vorlage {
   public $basis,$exponent; private $es,$vp;
   public function __construct($b,$h,$ef="") {
      if($b!==Null) $this->basis=$b; else $this->basis=new cl_fehler();
      if($h!==Null) $this->exponent=$h; else $this->exponent=new cl_fehler(); 
      $this->efarbe=$ef; }
   public function mass($fs,$os=Null) { 
      if(($m=$this->basis->mass($fs))<0) return $m;
      if($os===Null) $f=1; else $f=$os/$fs;
      $this->es=schriftcheck($fs,$f*KfgHsf); 
      if($this->es<0) return $this->es; // Formel noch einmal größer erstellen 
      if(($m=$this->exponent->mass($fs*$this->es))<0) return $m;  
      $eh=$this->es*$this->exponent->hoehe;
      if($this->basis->hoehe>$eh) $this->vp=$eh/2;
         else $this->vp=$eh-$this->basis->hoehe/2;
      $this->ohoehe=$this->basis->ohoehe+$this->vp;
      $this->uhoehe=$this->basis->uhoehe;
      $this->breite=$this->basis->breite+$this->es*$this->exponent->breite; }
   public function ausgabe($ef="") { 
   	$this->basis->nblock("Hochbasis",$this->vp);
		$this->basis->ausgabe($ef);      
      echo "</div>";
      $this->exponent->nblock("Hochexponent",0,$this->es);
		$this->exponent->ausgabe($ef);      
      echo "</div>"; }
   public function zeige() {
      zeige($this->basis,"Basis"); zeige($this->exponent,"Hoch"); }}

class cl_tiefhoch extends cl_vorlage {
   public $basis,$exponent,$index; private $es,$vb,$vu;
   public function __construct($b,$t,$h) {
      if($b!==Null) $this->basis=$b; else $this->basis=new cl_fehler();
      if($t!==Null) $this->index=$t; else $this->index=new cl_fehler();
      if($h!==Null) $this->exponent=$h; else $this->exponent=new cl_fehler(); }
   public function mass($fs,$os=Null) {
      if(($m=$this->basis->mass($fs))<0) return $m;
      if($os===Null) $f=1; else $f=$os/$fs;
      $this->es=schriftcheck($fs,$f*KfgHsf);
      if($this->es<0) return $this->es; // Formel noch einmal größer erstellen 
      if(($m=$this->exponent->mass($fs*$this->es))<0) return $m;
      if(($m=$this->index->mass($fs*$this->es))<0) return $m; 
      if($this->basis->hoehe>$this->es*$this->exponent->hoehe) 
          $this->vb=$this->es*$this->exponent->hoehe/2;
      else $this->vb=$this->es*$this->exponent->hoehe-$this->basis->hoehe/2;
      $ih=$this->index->hoehe;
      if($this->basis->hoehe>$this->es*$this->index->hoehe)
      	 $this->vu=$this->es*$this->index->hoehe/2;
      else $this->vu=$this->es*$this->index->hoehe-$this->basis->hoehe/2;
      $this->ohoehe=$this->basis->ohoehe+$this->vb;
      $this->uhoehe=$this->basis->uhoehe+$this->vu;
      $b=$this->exponent->breite;
      if($this->index->breite>$b) $b=$this->index->breite;
      $this->breite=$this->basis->breite+$this->es*$b; }
   public function ausgabe($ef="") {
		$this->basis->nblock("Tiefhochbasis",$this->vb); 
		$this->basis->ausgabe($ef);
		echo "</div>";
		$this->nblock("Tiefhoch");
		$this->exponent->ublock("Tiefhochexponent",0,$this->es,"text-align:left");
		$this->exponent->ausgabe($ef);
		echo "</div>"; 
		$this->index->nblock("Tiefhochindex",
			$this->hoehe-$this->es*($this->exponent->hoehe+$this->index->hoehe),$this->es);
		$this->index->ausgabe($ef);
		echo "</div></div>"; }
   public function zeige() {
      zeige($this->basis,"Basis");
      zeige($this->exponent,"Hoch"); zeige($this->index,"Tief"); }}

class cl_untenoben extends cl_vorlage {
   public $basis,$unten=Null,$oben=Null; private $es;
   public function __construct($b,$u,$o) {
      if($b!==Null) $this->basis=$b; else $this->basis=new cl_fehler();
      $this->oben=$o; $this->unten=$u; }
   public function mass($fs,$os=Null) {
      if(($m=$this->basis->mass($fs))<0) return $m;
      if($os===Null) $f=1; else $f=$os/$fs; 
      $this->es=schriftcheck($fs,$f*KfgGsf);
      if($this->es<0) return $this->es; // Formel noch einmal größer erstellen 
      $this->uhoehe=$this->basis->uhoehe; $this->ohoehe=$this->basis->ohoehe;
      $this->breite=$this->basis->breite;
      if($this->unten!==Null) {
         if(($m=$this->unten->mass($fs*$this->es))<0) return $m;
         $this->uhoehe+=$this->es*($this->unten->hoehe+KfgVpd);
         if($this->es*$this->unten->breite>$this->breite) $this->breite=$this->es*$this->unten->breite; }
      if($this->oben!==Null) {
         if(($m=$this->oben->mass($fs*$this->es))<0) return $m;
         $this->ohoehe+=$this->es*($this->oben->hoehe+KfgVpd);
         if($this->es*$this->oben->breite>$this->breite) $this->breite=$this->es*$this->oben->breite; }}
   public function ausgabe($ef="") { 
		$this->nblock("UntenOben");
		if($this->oben!==Null) {
			$this->oben->ublock("Oben",0,$this->es,"margin-bottom:".KfgVpd."em");
			$this->oben->ausgabe($ef); echo "</div>"; }		   
  		$this->basis->ublock("Basis",0,1);
  		$this->basis->ausgabe($ef); echo "</div>";
		if($this->unten!==Null) {  		
			$this->unten->ublock("Unten",KfgVpd,$this->es);		   
  			$this->unten->ausgabe($ef); echo "</div>"; }
  		echo "</div>"; } 
   public function zeige() {
      zeige($this->basis,"Basis");
      if($this->unten||$this->oben) {
         echo "<div style='margin-left:3em'>\n";
         if($this->unten!==Null) zeige($this->unten,"Unten");
         if($this->oben!==Null) zeige($this->oben,"Oben");
         echo "</div>"; }}}

class cl_reihe extends cl_vorlage {
   public $symbol,$inhalt; private $bs,$es;
   public function __construct($op,$sm) {
      for($i=0;$i<count($sm);$i++) {
         if($sm[$i]===Null) $sm[$i]=new cl_fehler(); }
      $this->inhalt=$sm; $this->symbol=$op; }
   public function mass($fs) {
      $this->es=1; $this->bs=Null;
      if($this->symbol=="/") {
      	$this->es=schriftcheck($fs,KfgBsf);
	      if($this->es<0) return $this->es; // Formel noch einmal größer erstellen
         $this->bs=KfgBst; if($this->bs*$fs*15<1) $this->bs=0; }  
      $h=0; $a=0; $b=0;
      foreach($this->inhalt as $mi) {
         if(($m=$mi->mass($fs*$this->es))<0) return $m;
         $a++; $h+=$mi->hoehe;
         if($mi->breite>$b) $b=$mi->breite; }
      $this->breite=$this->es*$b;
      if($this->bs!==Null) {
      	if(count($this->inhalt)==2) { 
         	$this->ohoehe=$this->inhalt[0]->hoehe*$this->es+($this->bs+KfgVpd)/2; 
         	$this->uhoehe=$this->inhalt[1]->hoehe*$this->es+($this->bs+KfgVpd)/2; }
      	else { 
         	$h=($this->es*$h+(count($this->inhalt)-1)*($this->bs+KfgVpd))/2;
         	$this->ohoehe=$h; $this->uhoehe=$h; }}
      else {
        	$h=$this->es*($h+(count($this->inhalt)-1)*KfgVpd)/2;  
        	$this->ohoehe=$h; $this->uhoehe=$h; }}
   public function ausgabe($ef="") {
      $this->nblock("Reihe");
      for($i=0;$i<count($this->inhalt);$i++) {
         $ih=$this->inhalt[$i];
			if($i&&$this->bs!==Null) {
				echo "<div style='height:".($this->bs?$this->bs."em":"1px").";".
							 "background-color:".($ef?$ef:"black").";".
				          "margin-top:".(KfgVpd/2)."em;margin-bottom:".(KfgVpd/2)."em'></div>\n";
				$ih->ublock("Bruchelement",0,$this->es); }
			else 								
				$ih->ublock("Reihenelement",0,$this->es,($i?"margin-top:".KfgVpd."em":""));
			$ih->ausgabe($ef); echo "</div>"; }
		echo "</div>"; }	
   public function zeige() {
      echo $this->symbol;
      for($i=0;$i<count($this->inhalt);$i++) zeige($this->inhalt[$i],"[".$i."]"); }}

class cl_matrix extends cl_vorlage {
   public $inhalt; private $za,$sa,$zh;
   public function __construct($sm) {
      for($s=0;$s<count($sm);$s++) {
         if(klasse($sm[$s])=="cl_reihe"&&$sm[$s]->symbol="#")
            $sm[$s]=$sm[$s]->inhalt;
         elseif(!is_array($sm[$s])) $sm[$s]=array($sm[$s]);
         for($z=0;$z<count($sm[$s]);$z++) {
            if($sm[$s][$z]===Null) $sm[$s][$z]=new cl_fehler(); }}
      $this->inhalt=$sm; }
   public function mass($fs) {
      $this->za=1; $this->sa=count($this->inhalt);
      foreach($this->inhalt as $s) {
         if(count($s)>$this->za) $this->za=count($s); }
      for($s=0;$s<$this->sa;$s++) {
         $si=$this->inhalt[$s];
         if(count($si)<$this->za)
            $this->inhalt[$s]=array_merge(
               $si,array_fill(0,$this->za-count($si),new cl_fehler())); }
      $uh=array(); $oh=array(); $this->zh=array(); $br=array(); $hz=0;
      for($z=0;$z<$this->za;$z++) {
         $o=0; $u=0;
         for($s=0;$s<$this->sa;$s++) {
            $b=$this->inhalt[$s][$z]; 
            if(($m=$b->mass($fs))<0) return $m;
            if($b->ohoehe>$o) $o=$b->ohoehe;
            if($b->uhoehe>$u) $u=$b->uhoehe;
            if($z==0) $br[$s]=0;
               elseif($b->breite>$br[$s]) $br[$s]=$b->breite; }
         $this->zh[$z]=$o+$u; // Höhe Zeile z
			$hz+=$this->zh[$z]; }
		$hz+=($this->za-1)*KfgVpd;	                 
      $this->ohoehe=$hz/2; $this->uhoehe=$hz/2;
      $this->breite=($this->sa-1)*KfgVpd;
      for($s=0;$s<$this->sa;$s++) $this->breite+=$br[$s]; }
   public function ausgabe($ef="") {
		$this->nblock("Matrix");      
      for($s=0;$s<$this->sa;$s++) {
      	echo "<div class='wpformel neben'".($s?" style='margin-left:".KfgVpd."em'":"").">\n"; 
         for($z=0;$z<$this->sa;$z++) {
            $ih=$this->inhalt[$s][$z];
            $ih->ublock("Matrixelement",($this->zh[$z]-$ih->hoehe)/2+($z?KfgVpd:0),1,"height:".($this->zh[$z]+($z?KfgVpd:0))."em;vertical-align:middle");
            $ih->ausgabe($ef);
			   echo "</div>"; }
			echo "</div>"; }
		echo "</div>"; }	      
   public function zeige() {
      for($s=0;$s<$this->sa;$s++) {
         for($z=0;$z<count($this->inhalt[$s]);$z++)
            zeige($this->inhalt[$s][$z],"[".$z.",".$s."]"); }}}

class cl_ausdruck extends cl_vorlage {
   protected $inhalt,$iohoehe,$ihoehe,$ipv=0;
   // iohoehe: mit Anpasser kann die nach außen wirkende Oberhöhe anders sein als die
   // ursprüngliche innere Oberhöhe (iohoehe), die in innenausgabe() verwendet wird.
   public function __construct($ih,$leer=false) {
      if(!$ih) $ih=array();
      if(!is_array($ih)) $ih=array($ih);
      if(!count($ih)) {
         if($leer) $ih[]=new cl_zeichen("");
              else $ih[]=new cl_fehler(); }
      $this->inhalt=$ih; }
   public function mass($fs) {
      $this->breite=0;
      foreach($this->inhalt as $b) {
         if(($m=$b->mass($fs))<0) return $m; 
         if($b->uhoehe>$this->uhoehe) $this->uhoehe=$b->uhoehe;
         if($b->ohoehe>$this->ohoehe) $this->ohoehe=$b->ohoehe;
         $this->breite+=$b->breite; }
      $this->iohoehe=$this->ohoehe; $this->ihoehe=$this->hoehe;   
      if($this->inhalt[0]->anpass) $this->anpass=$this->inhalt[0]->anpass; }
   public function ausgabe($ef="") { 
      $this->nblock("Ausdruck",0,1); 
      $this->innenausgabe($ef); 
      echo "</div>"; } 
   protected function innenausgabe($ef="") { 
   	foreach($this->inhalt as $b) { 
         if(!$b->breite) continue; 
         $d=($this->iohoehe-$b->ohoehe+$this->ipv);
         if(klasse($b)=="cl_operator"&&$b->hoehe==KfgZmm&&$this->ihoehe<=KfgZmm) $d+=KfgVop;
         	// Kleine Operatoren in kleiner Umgebung tiefer setzen.
			$this->nblock("Innenausdruck",$d);
         $b->ausgabe($ef);
         echo "</div>"; }}
   public function zeige() {
      foreach($this->inhalt as $b) zeige($b); }}

class cl_anpassausdruck extends cl_ausdruck {
	protected $anpasser,$apzeichen,$anpassung,$aps;
   public function __construct($ap,$ih,$az) {
      parent::__construct($ih,false);
      $this->anpasser=$ap; 
      $this->apzeichen=$az; 
      $this->anpassung=$az->anpassung; }
   public function mass($fs) {
		// Anpassung:
    	// 1: Keine Größenanpassung; das Zeichen wird in normaler Größe dargestellt.
    	// 2: Das Zeichen wird so hoch wie der folgende Ausdruck; vertikale Umgebungs-Ausrichtung erfolgt an der Basislinie des Ausdrucks.
    	// 3: Das Zeichen wird so hoch wie der folgende Ausdruck; vertikale Umgebungs-Ausrichtung erfolgt mittig.
    	// 4: Das Zeichen wird so hoch, dass Zeichen und Ausdruck vertikal mittig ausgerichtet werden können.
      global $Anpasser;
      if($this->anpassung===Null) // für Klammern bereits in construct erledigt
         $this->anpassung=$Anpasser[$this->apzeichen->wert]; // default
      if($this->anpassung==1) array_unshift($this->inhalt,$this->anpasser);
      if(($m=parent::mass($fs))<0) return $m; // pure Maße
      if($this->anpassung<2) return;
      $this->iohoehe=$this->ohoehe; $this->ihoehe=$this->hoehe;   
		$this->anpasser->mass($fs);
			// Anpasser: Apzeichen und Grenzen in gleicher Schriftgröße
      switch($this->anpassung) { 
         case 2: case 3: $zh=$this->hoehe; $av=0; break;
         case 4: if($this->ohoehe>$this->uhoehe) { $zh=2*$this->ohoehe; $av=0; }
                    else { $zh=2*$this->uhoehe; $av=$this->uhoehe-$this->ohoehe; }
                 break; }
			// innerer Ausdruck: im Fall 4 mittig zum Anpasser setzen                     
      if($this->anpass!=$this->apzeichen->wert) $azh=$zh*KfgKsf; else $azh=$zh;  
	      // Wunschgröße für apzeichen; (gleiche nur erstmals größer)
	   $this->anpass=$this->apzeichen->wert;   
      $this->aps=$azh/$this->apzeichen->hoehe; 
	      // Vergrößerungsfaktor, um Anpasserzeichen auf Wunschgröße zu bringen
      if($this->aps<1) { // keine Verkleinerung des Anpassers  
      	$this->anpassung=1; 
      	array_unshift($this->inhalt,$this->anpasser);
      	parent::mass($fs); return; } 
      $go=$this->anpasser->ohoehe-$this->apzeichen->ohoehe;
      $gu=$this->anpasser->uhoehe-$this->apzeichen->uhoehe;
         // Höhe obere/untere Grenze, wenn vorhanden (werden nicht vergrößert)
      $dh=($azh-$zh)/2; 
      	// halbe Differenz zwischen Höhen Anpasszeichen (vergrößert) und Ausdruck
      $this->ipv=$dh+$go+$av;    
      if(($m=$this->anpasser->mass($this->aps*$fs,$fs))<0) return $m;
      	// Anpasser neu berechnen mit vergrößertem Anpasserzeichen und evtl. denselben Grenzen
      	// basiert noch auf fs, also ohne die Vergrößerung der Grenzen um aps; so gespeichert
         // 2.Parameter nur für untenoben, index, exponent, wurzelgrad
      $gzh=$this->aps*$this->anpasser->hoehe;
         // Gesamthöhe Anpasser mit Grenzen, jetzt vergrößert, nicht gespeichert
      switch($this->anpassung) {
         case 2: $this->ohoehe=$this->ohoehe+$go+$dh; $this->uhoehe=$this->uhoehe+$gu+$dh; break;  
         case 3: case 4: $this->ohoehe=$gzh/2; $this->uhoehe=$gzh/2; break; }
      $this->breite=$this->breite+$this->anpasser->breite*$this->aps; }
   public function ausgabe($ef="") {
      if($this->anpassung>1) { 
      	$this->anpasser->nblock("Anpassausdruck",0,1);
        	$this->anpasser->nblock("Anpassoperator",0,$this->aps);
         $this->anpasser->ausgabe($ef);
         echo "</div>";
         $this->innenausgabe($ef);
         echo "</div>"; }
      else parent::ausgabe($ef); }
   public function zeige() {
      if($this->anpasser->anpassung!==Null)
         echo "<span style='font-size:smaller'>$".
              $this->anpasser->anpassung."</span>";
      if($this->anpassung>1) zeige($this->anpasser);
      parent::zeige(); }}

class cl_klammerausdruck extends cl_ausdruck { // siehe auch cl_anpassausdruck
   protected $anpasser,$anpassung,$aps,$kla,$klz;
   function __construct($ih,$ka,$kz) {
   global $Klammer;
      parent::__construct($ih,true);
      if($ka->anpassung===Null&&$kz->anpassung===Null) {
         $ka->anpassung=$Klammer[$ka->wert]["ap"];
         $kz->anpassung=$Klammer[$ka->wert]["ap"]; }
      else {
         if($ka->anpassung) {
            if($kz->anpassung!==0) $kz->anpassung=$ka->anpassung; }
         elseif($ka->anpassung===Null) $ka->anpassung=$kz->anpassung; }
      $this->kla=new cl_apzeichen($ka->wert,$ka->anpassung);
      $this->klz=new cl_apzeichen($kz->wert,$kz->anpassung);
      if($ka->anpassung) {
         $this->anpasser=$this->kla;
         $this->anpassung=$this->kla->anpassung; }
      else {
         $this->anpasser=$this->klz;
         $this->anpassung=$this->klz->anpassung; }}
   public function mass($fs) {
      if($this->anpassung==1) {
         if($this->kla->anpassung) array_unshift($this->inhalt,$this->kla);
         if($this->klz->anpassung) $this->inhalt[]=$this->klz; }
      if(($m=parent::mass($fs))<0) return $m; // pure Maße
      if($this->anpassung<2) return;
      $this->iohoehe=$this->ohoehe; $this->ihoehe=$this->hoehe;
      $this->kla->mass($fs); $this->klz->mass($fs); 
      switch($this->anpassung) {
         case 2: case 3: $zh=$this->hoehe; $av=0; break;
         case 4: if($this->ohoehe>$this->uhoehe) { $zh=2*$this->ohoehe; $av=0; }
                    else { $zh=2*$this->uhoehe; $av=$this->uhoehe-$this->ohoehe; }
                 break; }
			// innerer Ausdruck: im Fall 4 mittig zur Klammer setzen                     
      if($this->anpass!=$this->kla->wert) $azh=$zh*KfgKsf; else $azh=$zh; 
	      // Wunschgröße für Klammer; (gleiche nur erstmals größer)
	   $this->anpass=$this->kla->wert;   
      $this->aps=$azh/$this->anpasser->hoehe; 
	      // Vergrößerungsfaktor, um Anpasserzeichen auf Wunschgröße zu bringen
      if($this->aps<1) { // keine Verkleinerung des Klammer: Ausgabe wie $1
      	$this->anpassung=1; 
      	if($this->kla->anpassung) array_unshift($this->inhalt,$this->kla);
         if($this->klz->anpassung) $this->inhalt[]=$this->klz; 
      	parent::mass($fs); return; } 
      $dh=($azh-$zh)/2; $this->ipv=$dh+$av; 
         // halbe Differenz zwischen Höhen Klammer (vergrößert) und Ausdruck
      if(($m=$this->anpasser->mass($this->aps*$fs))<0) return $m; 
		$gzh=$this->aps*$this->anpasser->hoehe;
      switch($this->anpassung) { // Gesamthöhen des Ausdrucks mit Klammer
         case 2: $this->ohoehe=$this->ohoehe+$dh; $this->uhoehe=$this->uhoehe+$dh; break; 
         case 3: case 4: $this->ohoehe=$gzh/2; $this->uhoehe=$gzh/2; break; }
      $this->breite=$this->breite+
         ($this->kla->anpassung?$this->kla->breite*$this->aps:0)+
         ($this->klz->anpassung?$this->klz->breite*$this->aps:0); }
   public function ausgabe($ef="") {
      if($this->anpassung>1) {
      	$this->nblock("Klammerausdruck");
         if($this->kla->anpassung) {
         	$this->nblock("Klammerauf",0,$this->aps);
         	$this->kla->ausgabe($ef);
         	echo "</div>"; } 
         $this->innenausgabe($ef);
         if($this->klz->anpassung) {
         	$this->nblock("Klammerzu",0,$this->aps);
         	$this->klz->ausgabe($ef);
         	echo "</div>"; }
         echo "</div>"; }
      else  parent::ausgabe($ef); }
   public function zeige() {
      $u="";
      if($this->kla->anpassung)
         $u="$".$this->kla->anpassung."&nbsp;";
      if($this->kla->anpassung===0) $u.="unsichtbar";
      if($u) echo "<span style='font-size:smaller'>".$u."</span>".
         "&nbsp;&nbsp;&nbsp;";
      $u="";
      if($this->klz->anpassung)
         $u="$".$this->klz->anpassung."&nbsp;";
      if($this->klz->anpassung===0) $u.="unsichtbar";
      if($u) echo "<span style='font-size:smaller'>".$u."</span>";
      parent::zeige(); }}

class cl_wurzelausdruck extends cl_ausdruck { // siehe auch anpassausdruck
   private $grad,$apzeichen,$aps,$wzs,$grs,$ws;
   public function __construct($g=Null,$w=Null,$a=Null) {
      parent::__construct($w,false);
      if($g!==Null&&klasse($g)!="cl_zeichenfolge") $g=new cl_fehler();
      $this->grad=$g;
      $this->apzeichen=new cl_apzeichen("√",$a);
      $this->anpassung=$a; }
   public function mass($fs) {
   global $Anpasser;
      if($this->anpassung===Null||$this->anpassung==1)
         $this->anpassung=$Anpasser["√"]; // default
      if(($m=parent::mass($fs))<0) return $m; // pure Maße des Wurzelarguments
      $this->ws=KfgWst; if($this->ws*$fs*15<1) $this->ws=0;
         // Wurzelstrich nicht kleiner 1/15em (1px) 
      $this->iohoehe=$this->ohoehe; $this->ihoehe=$this->hoehe;
      $this->apzeichen->mass($fs); // originale Maße des Wurzelzeichens (ohne Strich)
      $av=0;
     	switch($this->anpassung) {
        	case 2: case 3: $zh=$this->hoehe; $av=0; break;
        	case 4: if($this->ohoehe>$this->uhoehe) { $zh=2*$this->ohoehe; $av=0; } 
          	        else { $zh=2*$this->uhoehe; $av=$this->uhoehe-$this->ohoehe; }
           	     break; }
			// innerer Ausdruck: im Fall 4 mittig zum Anpasser setzen
		$azh=$zh+$this->ws+KfgWsp; 
	      // Wunschgröße für Wurzelzeichen ( Ausdruck mit Strich ) 
	   $this->anpass=$this->apzeichen->wert;   
      $this->aps=$azh/$this->apzeichen->hoehe; 
	      // Vergrößerungsfaktor, um Wurzelzeichen auf Wunschgröße zu bringen
      $this->ipv=$azh-$zh+$av; 
         // Differenz zwischen Höhen Wurzel (vergrößert) und Ausdruck
      if(($m=$this->apzeichen->mass($this->aps*$fs))<0) return $m;
      	// neu berechnen 
      $gzh=$this->aps*($this->apzeichen->hoehe);
         // Gesamthöhe Wurzelausdruck, jetzt vergrößert, nicht gespeichert
      switch($this->anpassung) { // Gesamthöhen des Ausdrucks mit Wurzel
         case 2: $this->ohoehe=$this->ohoehe+$this->ws+KfgWsp; $this->uhoehe=$this->uhoehe; break;  
         case 3: case 4: $this->ohoehe=$gzh/2; $this->uhoehe=$gzh/2; break; }
      $this->breite=$this->breite+$this->apzeichen->breite*$this->wzs;
      if($this->grad!==Null) {
         $this->grs=schriftcheck($fs,KfgWgf);
         if($this->grs<0) return $this->es; // Formel noch einmal größer erstellen 
         if(($m=$this->grad->mass($fs*$this->grs))<0) return $m;
         $bg=$this->grad->breite*$this->grs-KfgWph;
         if($bg>0) $this->breite+=$bg*$this->grs; }} // Grad ragt über Wurzelzeichen
   public function ausgabe($ef="") {
    	$this->nblock("Wurzel");
     	if($this->grad!==Null) {
     		$this->grad->nblock("Wurzelgrad",0,$this->grs,"margin-right:".(-KfgWph)."em;margin-top:".KfgWpv."em");
     		$this->grad->ausgabe($ef);
     		echo "</div>";	} 
     	$this->apzeichen->nblock("Wurzeloperator",0,$this->aps);
      $this->apzeichen->ausgabe($ef);
      echo "</div>";
      echo "</div>";
      $this->nblock("Wurzelargument",0,1,"border-top:".($this->ws?$this->ws."em":"1px")." solid ".($ef?$ef:"black"));
      $this->innenausgabe($ef);
      echo "</div>"; }
   public function zeige() {
      if($this->grad!==Null) zeige($this->grad);
      parent::zeige(); }}

class cl_eigenausdruck extends cl_ausdruck {
public $eigentag,$eigenschaft,$sg;
   public function __construct($ei,$ih) {
      parent::__construct($ih,false);
      $this->eigentag=$ei;
      $this->eigenschaft=$ei->eigenschaft; }
   public function mass($fs) {
   	$this->sg=1;
      if(array_key_exists("sg",$this->eigenschaft)) {
			$f=$this->eigenschaft["sg"]; $p=false;
			if(mb_substr($f,mb_strlen($f)-1,1)=="%") {
				$f=mb_substr($f,0,strlen($f)-1); $p=true; }
			if(is_numeric($f)) { 
				if($p) $this->sg=$f/100; 
					elseif($f>KfgSgp) $this->sg=$f/100; 
					else $this->sg=$f; }}
      if(($m=parent::mass($this->sg*$fs))<0) return $m; 
      $this->iohoehe=$this->ohoehe; $this->ihoehe=$this->hoehe; }
   public function ausgabe($ef="") {
   	$s=""; 
      if(array_key_exists("sf",$this->eigenschaft)) {
      	$ef=$this->eigenschaft["sf"];	$s.="color:".$ef.";"; }
      if(array_key_exists("hf",$this->eigenschaft)) 
         $s.="background-color:".$this->eigenschaft["hf"].";";
      $this->nblock("Eigenausdruck",0,$this->sg,$s);      
      $this->innenausgabe($ef);
      echo "</div>"; }
   public function zeige() {
      $this->eigentag->zeige();
      parent::zeige(); }}

// Parser:

class pc_zeichen {
   var $wert;
   function __construct($y=Null) {
      $this->wert=$y; }
   function ausgabe($aus="") {
      if($this->wert=="〈"||$this->wert=="〉")
         echo "<span style='line-height:1em;'>";
      echo klasse($this).": ";
      if($aus) echo $aus; elseif($this->wert) echo $this->wert;
      if($this->wert=="〈"||$this->wert=="〉")
         echo "</span>";
      echo "<br />\n"; }}
class pc_zwraum extends pc_zeichen {}
class pc_posop extends pc_zeichen {}
class pc_funktion extends pc_zeichen {}
class pc_schluss extends pc_zeichen {}
class pc_zeichenfolge extends pc_zeichen {}
class pc_operator extends pc_zeichen {}
class pc_fehler extends pc_zeichen {}
class pc_text extends pc_zeichen {
   var $anfzeichen;
   function __construct($y=Null,$af="") {
      parent::__construct($y);
      $this->anfzeichen=$af; }
   function ausgabe($aus="") { 
      parent::ausgabe($this->anfzeichen.$this->wert.$this->anfzeichen); }}
class pc_anpasser extends pc_zeichen {
   var $anpassung;
   function __construct($y=Null,$ap=Null) {
      parent::__construct($y);
      $this->anpassung=$ap; }
   function ausgabe($aus="") {
      if($this->anpassung) $u="$".$this->anpassung."&nbsp;";
         else $u=""; // Null,0
      if($this->anpassung===0) $u.="unsichtbar";
      parent::ausgabe($this->wert.
                     ($u?"<span style='font-size:smaller'>".$u.
                         "</span>":""));}}
class pc_wurzel extends pc_anpasser {
   function __construct($ap=Null) {
      $this->wert="√";
      $this->anpassung=$ap; }}
class pc_klammer extends pc_anpasser {}
class pc_eigentag extends pc_zeichen {
   public $eigenschaft=Null;
   public function __construct($w="") {
      parent::__construct($w);
      $eig=Null;
      $ei=explode(";",$w);
      foreach($ei as $e) {
         if(trim($e)=="") continue;
         $s=explode(":",$e);
         if(count($s)!=2) return;
         if(!in_array(trim($s[0]),array("sf","hf","sg"))) return;
         $eig[trim($s[0])]=trim($s[1]); }
      if(count($eig)==0) return;
      $this->eigenschaft=$eig; }}

function wps_zeichenfolge($zf,&$ftz) {
global $Funktion;
   if(count($ftz)>0) {
      $g=$ftz[count($ftz)-1];
      if(klasse($g)=="pc_funktion"&&$g->wert===Null) {
         array_pop($ftz); $g->wert=$zf; return $g; }}
   if(in_array($zf,$Funktion)) return new pc_funktion($zf);
   return new pc_zeichenfolge($zf); }

function wps_symbol($ftx,&$fp) {
	global $Mehrfach;
   $y=mb_substr($ftx,$fp,1); 
	if($y=="&") { // html-entity
   	$e=""; $f=$fp+1;
   	while($f<mb_strlen($ftx)) {
      	$y=mb_substr($ftx,$f,1);  
      	if(($y<"a"||$y>"z")&&($y<"A"||$y>"Z")&&($y<"0"||$y>"9")&&$y!="#") break;
      	$e.=$y; $f++; }
   	if($y==";"&&$e) {
      	$fp=$f;
      	if($e=="nbsp") return " ";
      	elseif($e=="radic") return "§";
      	else {
      		$hc=html_entity_decode("&".$e.";",ENT_COMPAT,"UTF-8");
      		if(mb_strlen($hc)==1) return $hc;
      		return "&amp;".mb_substr($hc,1); }}
   	else return "&"; }
   elseif($y=="%"&&$fp<mb_strlen($ftx)) { // evtl. griechischer Buchstabe
		$x=mb_substr($ftx,$fp+1,1); $xg=strtoupper($x);	$g=mb_strpos(Griechisch,$xg);
		if($g!==false) { // griechischer Buchstabe
			if($x==$xg) $a=913; else $a=945; 
			$y=html_entity_decode("&#".($a+$g).";",ENT_COMPAT,"UTF-8");
			$fp++; return $y; }}
	else {
      for($l=3;$l>=2;$l--) { // dreifache und doppelte   
         if($fp<mb_strlen($ftx)-$l+1) {
           	if(array_key_exists(mb_substr($ftx,$fp,$l),$Mehrfach)) {
              	$y=$Mehrfach[mb_substr($ftx,$fp,$l)];
              	$fp+=$l-1; return $y; }}}
      return $y; }} // kein Ersatzzeichen        	 

function wps_zeichen($ftx) {
global $Klammer,$Klammerzu,$Operator,$Mehrfach,$Anpasser;
   $ftz=array(); $fp=0;
   $zf=""; $zw=0; $ob=Null;
   while($fp<mb_strlen($ftx)) {
      if(mb_substr($ftx,$fp,1)=="\\") { // Originalzeichen
         if($fp<mb_strlen($ftx)-1) { $fp++; $y=htmlentities(mb_substr($ftx,$fp,1)); }
            else $ob=new pc_fehler("\\"); }
      else {
         $y=wps_symbol($ftx,$fp); 
         if($y===" ") $y=" ";
         if($y=="´"||$y=="`") {
            $f=$fp; $fp++; $x="";
            while($fp<mb_strlen($ftx)&&mb_substr($ftx,$fp,1)!=$y) {
            	if($y=="`") {
            		$z=mb_substr($ftx,$fp,1); 
            		if($z==" ") $x.="&nbsp;"; else $x.=htmlentities(mb_substr($ftx,$fp,1)); } 
            	else $x.=wps_symbol($ftx,$fp);
            	$fp++; }
            if(mb_substr($ftx,$fp,1)==$y) { $ob=new pc_text($x,$y); } 
               else { $fp=$f; $ob=new pc_fehler($y); }}
         if($y=="@"&&$fp<mb_strlen($ftx)&&mb_substr($ftx,$fp+1,1)=="<") { // Makro
            $f=$fp; $fp+=2; $m=wps_makro($ftx,$fp); 
            if($m) {
               $ftx=mb_substr($ftx,0,$f).$m.mb_substr($ftx,$fp); 
               $fp=$f; continue; } 
            $fp=$f; }
         if(in_array($y,$Operator)) $ob=new pc_operator($y);
         if($y=="^"||$y=="_"||$y=="#") { // ignoriert vorhergehendes $
            if($fp<mb_strlen($ftx)&&mb_substr($ftx,$fp+1,1)===$y) {
               $fp++; $ob=new pc_posop($y.$y); }
            else $ob=new pc_posop($y); }
         if($y=="/") $ob=new pc_posop($y);
         // Klammer,Anpasser,Wurzel mit default-Anpassung:
         if(array_key_exists($y,$Klammer)||in_array($y,$Klammerzu)) $ob=new pc_klammer($y,Null);
         if($y=="§") $ob=new pc_wurzel(Null);
         	elseif(array_key_exists($y,$Anpasser)) $ob=new pc_anpasser($y,Null);
         if($y=="$") { // ap=Null: nicht angegeben: default
                       // $: macht Nichtoperatoren zu Operatoren
                       // $0: macht Klammer unsichtbar
                       // $1-$4: Anpasser oder Klammer:
                       // 1: Normale Schriftgröße
                       // 2: größenangepasst,
                       // 3: lagenangepasst,
                       // 4: symmetrisch angepasst
                       // <...>: Eigenschaften
            if($fp>=mb_strlen($ftx)-1) $ob=new pc_fehler("$");
            else { // $...
               $fp++; $x=wps_symbol($ftx,$fp);
               if($x>="0"&&$x<="9") { // $ziffer
                  $a=intval($x);
                  if($fp>=mb_strlen($ftx)-1||$a>4) $ob=new pc_fehler("$".$x);
                  else { // $[0-4]...
                     $fp++; $z=wps_symbol($ftx,$fp);
                     if($a==0) { // $0...
                        if(!isset($Klammer[$z])&&!in_array($z,$Klammerzu))
                           $ob=new pc_fehler("$0".$z); // keine Klammer
                        else $ob=new pc_klammer($z,0); }
                             // => unsichtbare Klammer
                     else { // $[1-4]
                        if(isset($Klammer[$z])||in_array($z,$Klammerzu))
                           $ob=new pc_klammer($z,$a); // =>angepasste Klammer
                        elseif($z=="§") $ob=new pc_wurzel($a);
                             // angepasste Wurzel
                        else $ob=new pc_anpasser($z,$a); }}}
                             // angepasster Anpasser
               else { // $... (keine Ziffer)
                  if($x=="<") { // Eigenschaften
                     $f=$fp; $fp++;
                     while($fp<mb_strlen($ftx)&&mb_substr($ftx,$fp,1)!=">") $fp++;
                     if(mb_substr($ftx,$fp,1)==">") {
                        $ob=new pc_eigentag(mb_substr($ftx,$f+1,$fp-$f-1));
                        if($ob->eigenschaft===Null)
                           $ob=new pc_fehler("$<".$ob->wert.">"); }
                     else { $fp=$f; $ob=new pc_fehler("$<"); }}
                  elseif(($x<"a"||$x>"z")&&($x<"A"||$x>"Z"))
                     $ob=new pc_operator($x);
                         // $kein Buchstabe: => gesetzter Operator
                  else { $ob=new pc_funktion(); $fp--; }}}}}
                       // $Buchstabe: folgt Funktion
                       // die folgende Zeichenfolge wird Wert (Funktionsname) einsetzen
      $fp++;
      if($ob!==Null) {
         if($zf!=="") { $ftz[]=wps_zeichenfolge($zf,$ftz); $zf=""; }
         if($zw) { $ftz[]=new pc_zwraum($zw); $zw=0; }}
      if($y==" ") {
         if($zf!=="") { $ftz[]=wps_zeichenfolge($zf,$ftz); $zf=""; }}
      else {
         if($zw) { $ftz[]=new pc_zwraum($zw); $zw=0; }}
      if($ob!==Null) { $ftz[]=$ob; $ob=Null; }
      else {
         if($y==" ") $zw++; else $zf.=$y; }
      if($fp>=mb_strlen($ftx)) {   
         if($zf!=="") { $ftz[]=wps_zeichenfolge($zf,$ftz); $zf=""; }
         if($zw) { $ftz[]=new pc_zwraum($zw); $zw=0; }}}
   $ftz[]=new pc_schluss(Null); 
   return $ftz; }

function wps_makro($ftx,&$fp) {
   $f=$fp; $x=""; $mn=""; $e=false; $par=array();
   while($fp<mb_strlen($ftx)&&!$e) {
      $y=mb_substr($ftx,$fp,1); $fp++;
      if($y=="@") {
         if(substr($x,mb_strlen($x)-1,1)==">") {
            $x=mb_substr($x,0,mb_strlen($x)-1); $e=true; }
         elseif($fp<mb_strlen($ftx)&&mb_substr($ftx,$fp,1)=="<") {
            $f=$fp; $fp++; $m=wps_makro($ftx,$fp);
            if($m) { $x.=$m; continue; }
            $fp=$f; }
         if(!$mn) {
            $mn=$x;
            if(!is_callable("mk".$mn)) { $fp=$f; return Null; }}
         else { if(is_string($x)&&$x!=="") $par[]=$x; else $par[]=Null; }
         $x=""; continue; }
      $x.=$y; }
   if(!$mn) return Null;
   $mf="mk".$mn; $e=$mf($par);
   if(!$e) { $fp=$f; return Null; }
   return $e; }

function wps_zeige($fb,$ftz) {
   echo "<p><b>Parser:</b><br />\n";
   foreach($ftz as $fz) $fz->ausgabe();
   echo "</p>\n<div><b>Struktur:</b><br />\n";
   zeige($fb);
   echo "</div>\n";}

class st_stack {
var $zeiger,$symbol;
   function __construct($z,$e) {
      $this->zeiger=$z; $this->element=$e; }}

function st_objekt($obn,$ftz,&$fp,&$stack,$schluss) {
   $f=$fp;
   if(array_key_exists($obn,$stack)&&array_key_exists($f,$stack[$obn])) {
      $fp=$stack[$obn][$f]->zeiger; return $stack[$obn][$f]->element; }
   $st="st_".$obn;
   $e=$st($ftz,$fp,$stack,$schluss);
   $stack[$obn][$f]=new st_stack($fp,$e);
   return $e; }

function st_element($ftz,&$fp,&$stack,$schluss) {
// Element = Text | Zeichenfolge | Posop (Operator mit Positionsveränderung) |
//           Ausdruck (in Klammer) | Schluss | Operatorzeichen | Funktion
global $Klammer;
   $g=$ftz[$fp]; $fp++;
   switch(klasse($g)) {
   case "pc_zeichenfolge": return new cl_zeichenfolge($g->wert);
   case "pc_funktion": return new cl_funktion($g->wert);
   case "pc_anpasser": return new cl_apzeichen($g->wert,$g->anpassung);
   case "pc_eigentag": return new cl_eigentag($g->wert,$g->eigenschaft);
   case "pc_fehler": return new cl_fehler($g->wert);
   case "pc_text": return new cl_text($g->wert,$g->anfzeichen);
   case "pc_posop": return $g;
           // wird nicht in Struktur gespeichert (kein cl_posop)
   case "pc_wurzel": return $g; // wie posop
   case "pc_operator":
      $g=new cl_operator($g->wert);
      if($fp<count($ftz)&&klasse($ftz[$fp])=="pc_zwraum") {
         $g->zwend=$ftz[$fp]->wert; $fp++; }
      return $g;
   case "pc_zwraum":
      if($fp<count($ftz)&&klasse($ftz[$fp])=="pc_operator") {
         $g=new cl_operator($ftz[$fp]->wert,$g->wert);
         $fp++;
         if($fp<count($ftz)&&klasse($ftz[$fp])=="pc_zwraum") {
            $g->zwend=$ftz[$fp]->wert; $fp++; }
         return $g; }
      else return new cl_zwraum($g->wert);
   case "pc_klammer":
      if($g->wert===$schluss) return new pc_schluss($g->wert); // KlammerZu
      if(!array_key_exists($g->wert,$Klammer)) return new cl_fehler($g->wert);
         // ungültige Klammerzu
      $kz=$Klammer[$g->wert]["zu"]; $f=$fp;
      $t=st_objekt("term",$ftz,$fp,$stack,$kz);
      $e=$ftz[$fp]; // muss Klammerzu sein; evtl. auch Schluss, wenn fehlt
      if(klasse($e)!=="pc_klammer"||$e->wert!==$kz) {
         $fp=$f; return new cl_fehler($g->wert); }
      $fp++; return new cl_klammerausdruck(st_ausdruck($t,true),$g,$e);
   case "pc_schluss": return $g; }}
      // keine Behandlung in Struktur (kein cl_schluss)

function st_posop($symbol,$ftz,&$fp,&$stack,$schluss) {
// [zwr entfernt] posoperator=symbol [zwr entfernt] => pc_posop || Null
   $f=$fp; $z=false; $g=st_objekt("element",$ftz,$fp,$stack,$schluss); 
   if(klasse($g)=="cl_zwraum") {
       $z=true; $g=st_objekt("element",$ftz,$fp,$stack,$schluss); }
      // zwraum vor posop ignorieren, aber nicht bei Wurzel
   if((klasse($g)!="pc_posop"&&(klasse($g)!="pc_wurzel")||$z)
       ||$g->wert!=$symbol) { $fp=$f; return Null; }
   $f=$fp; $z=st_objekt("element",$ftz,$fp,$stack,$schluss);
   if(klasse($z)!="cl_zwraum") $fp=$f;
      // evtl. zwraum nach posop ignorieren
   return $g; }

function st_ausdruck($a,$leer=false) {
   if(is_array($a)) return new cl_ausdruck($a,$leer); else return $a; }

function st_funktion_anpasser($ftz,&$fp,&$stack,$schluss) {
// { funktion | anpasser } [_...] [^...] [__...] [^^... ] operand
//    => { Array | cl_anpassausdruck } | Null
   $f=$fp; $g=st_objekt("element",$ftz,$fp,$stack,$schluss); $k=klasse($g);
   if($k!="cl_funktion"&&$k!="cl_apzeichen"&&$k!="cl_eigentag") { $fp=$f; return Null; }
   $a=$g;
   $g=st_tief($g,$ftz,$fp,$stack,$schluss);
   $g=st_hoch($g,$ftz,$fp,$stack,$schluss);
   $g=st_untenoben($g,$ftz,$fp,$stack,$schluss);
   $t=st_objekt("operand",$ftz,$fp,$stack,$schluss);
   if($t===Null) $t=new cl_fehler();
   if($k=="cl_funktion"||$g->anpassung==1) {
      if(is_array($t)) { array_unshift($t,$g); return $t; }
      return array($g,$t); }
   if($k=="cl_eigentag") return new cl_eigenausdruck($g,$t);
   return new cl_anpassausdruck($g,$t,$a); }

function st_vloperand($ftz,&$fp,&$stack,$schluss) { // vorzeichenloser Operand
// { Funktion | Anpassausdruck | Zeichenfolge | Text | Klammerausdruck |
//   Wurzelausdruck }
//     [_...] [^...] [__...] [^^...] => { cl_typ | Array } | Null
   $f=$fp; $g=st_objekt("funktion_anpasser",$ftz,$fp,$stack,$schluss);
   if($g===Null) {
      $g=st_objekt("element",$ftz,$fp,$stack,$schluss); $k=klasse($g);
      if($k!="cl_zeichenfolge"&&$k!="cl_text"&&$k!="cl_klammerausdruck")
         { $fp=$f; $g=Null; }}
   $g=st_wurzel(st_ausdruck($g),$ftz,$fp,$stack,$schluss);
   $g=st_tief(st_ausdruck($g),$ftz,$fp,$stack,$schluss);
   $g=st_hoch(st_ausdruck($g),$ftz,$fp,$stack,$schluss);
   $g=st_reihe(st_ausdruck($g),"/",$ftz,$fp,$stack,$schluss);
   $g=st_reihe(st_ausdruck($g),"#",$ftz,$fp,$stack,$schluss);
   $g=st_matrix(st_ausdruck($g),$ftz,$fp,$stack,$schluss);
   $g=st_untenoben(st_ausdruck($g),$ftz,$fp,$stack,$schluss);
   return $g; }

function st_operand($ftz,&$fp,&$stack,$schluss) {
// [unärOperator] vorzloserOperand => { Array | Operand }
global $Unaer,$test;
   $f=$fp; $u=st_objekt("element",$ftz,$fp,$stack,$schluss);
   if(klasse($u)=="cl_operator") {
      if(!in_array($u->wert,$Unaer)) { $fp=$f; return Null; }
      $x=true; }
   else {
      $x=false;
      if(klasse($u)!="cl_zwraum") { $fp=$f; $u=Null; }}
   $t=st_objekt("vloperand",$ftz,$fp,$stack,$schluss);
   if($u===Null) return $t;
   if($t===Null) { if($x) $t=new cl_fehler(); else return $u; }
   if(is_array($t)) { array_unshift($t,$u); return $t; }
   return array($u,$t); }

function st_wurzel($b,$ftz,&$fp,&$stack,$schluss) {
// Wurzel = Grad§Operand | Basiselement
//($b=Grad oder Basiselement, darf Null sein)
   $f=$fp; $o=st_posop("√",$ftz,$fp,$stack,$schluss);
   if($o!==Null) {
      $t=st_objekt("operand",$ftz,$fp,$stack,$schluss); // evtl. Null
      return new cl_wurzelausdruck($b,st_ausdruck($t),$o->anpassung); }
   $fp=$f; return $b; }

function st_tief($b,$ftz,&$fp,&$stack,$schluss) {
// Tief = Basiselement_Operandenfolge | Basiselement
   $f=$fp; $o=st_posop("_",$ftz,$fp,$stack,$schluss);
   if($o!==Null) {
      $t=st_objekt("operand",$ftz,$fp,$stack,$schluss); // evtl. Null
      if(klasse($t)=="cl_hoch")
         return new cl_tiefhoch($b,$t->basis,$t->exponent);
      return new cl_tief($b,st_ausdruck($t)); }
   $fp=$f; return $b; }

function st_hoch($b,$ftz,&$fp,&$stack,$schluss) {
global $test;
// Hoch = Basiselement^Operandenfolge | Basiselement
   $f=$fp; $o=st_posop("^",$ftz,$fp,$stack,$schluss);
   if($o!==Null) {
   $test=1;
      $t=st_objekt("operand",$ftz,$fp,$stack,$schluss); // evtl. Null
      return new cl_hoch($b,st_ausdruck($t)); }
   $fp=$f; return $b; }

function st_untenoben($b,$ftz,&$fp,&$stack,$schluss) {
// UntenOben = Basiselement__operand^^operand |
//             Basiselement^^operand__operand | Basiselement
   $f=$fp; $g=st_posop("__",$ftz,$fp,$stack,$schluss);
   if($g===Null) $g=st_posop("^^",$ftz,$fp,$stack,$schluss);
   if($g!==Null) {
      $t=st_objekt("operand",$ftz,$fp,$stack,$schluss); // evtl. Null
      if($g->wert=="__") { $u=$t; $o=Null; } else { $u=Null; $o=$t; }
      if(klasse($t)=="cl_untenoben") {
         if($u===Null&&$t->unten!==Null&&$t->oben===Null)
            return new cl_untenoben($b,$t->unten,$t->basis);
         if($o===Null&&$t->oben!==Null&&$t->unten===Null)
            return new cl_untenoben($b,$t->basis,$t->oben); }
      return new cl_untenoben($b,st_ausdruck($u),st_ausdruck($o)); }
   $fp=$f; return $b; }

function st_reihe($z,$op,$ftz,&$fp,&$stack,$schluss) {
   $sm=array($z);
   while(true) {
      $f=$fp; $o=st_posop($op,$ftz,$fp,$stack,$schluss);
      if($o===Null) break;
      $t=st_objekt("operand",$ftz,$fp,$stack,$schluss); // evtl. Null
      if(klasse($t)=="cl_reihe"&&$t->symbol==$op)
         $sm=array_merge($sm,$t->inhalt);
      elseif(klasse($t)=="cl_matrix"&&$o->wert=="#") {
         $t->inhalt[0]=array_merge($sm,$t->inhalt[0]);
         return $t; }
      else $sm[]=st_ausdruck($t); }
   $fp=$f;
   if(count($sm)==1) return $sm[0];
   return new cl_reihe($op,$sm); }

function st_matrix($z,$ftz,&$fp,&$stack,$schluss) {
   $sm=array($z);
   while(true) {
      $f=$fp; $o=st_posop("##",$ftz,$fp,$stack,$schluss);
      if($o===Null) break;
      $t=st_objekt("operand",$ftz,$fp,$stack,$schluss); // evtl. Null
      if(klasse($t)=="cl_matrix") $sm=array_merge($sm,$t->inhalt);
         else $sm[]=st_ausdruck($t); }
   $fp=$f;
   if(count($sm)==1) return $sm[0];
   return new cl_matrix($sm); }

function st_term($ftz,&$fp,&$stack,$schluss) { // RK: Array
// ausdruck =  { operand | unäroperator operand | funktion operand }
//               [ operator ausdruck ] ... bis Schluss | Null
   $tm=array(); $z=100; $op=false;
   while($z) {
      $z--; // Notbremse //
      $f=$fp; $g=st_objekt("operand",$ftz,$fp,$stack,$schluss);
      if($g===Null) {
         $g=st_objekt("element",$ftz,$fp,$stack,$schluss);
         if(klasse($g)=="pc_schluss") {
            $fp=$f;
            if($op) $tm[]=new cl_fehler();
            return $tm; }
         if(klasse($g)!="cl_zwraum") {
            if(klasse($g)!="cl_fehler") { $g=new cl_fehler(); $fp=$f; }}}
      if(is_array($g)) { $tm=array_merge($tm,$g); $op=false; }
         else { $tm[]=$g; if(klasse($g)!="cl_zwraum") $op=false; }
      $f=$fp; $g=st_objekt("element",$ftz,$fp,$stack,$schluss);
      if(klasse($g)=="cl_operator") { $tm[]=$g; $op=true; } else $fp=$f; }
   $fp=count($ftz)-1; // Ende Formel
   return new cl_fehler("Strukturfehler"); }

class cl_formel extends cl_ausdruck {
   private $fs=1;
   public function __construct($ih) {
      parent::__construct($ih,true); }
   public function mass($fs) {
      if(($m=parent::mass($fs))<0) return $m;
      $this->fs=$fs; }
   public function ausgabe($ef="") {
   global $WPF_EIG;
 		$we=""; 
		if(array_key_exists("sn",$WPF_EIG)) 
 			$we.="font-family=".$WPF_EIG["sn"].",\"Liberation Serif\",\"Times New Roman\",Serif;";
		if(array_key_exists("sf",$WPF_EIG)) { $ef=$WPF_EIG["sf"]; $we.="color:".$ef.";";  } 
		if(array_key_exists("hf",$WPF_EIG)) $we.="background-color:".$WPF_EIG["hf"].";";
		$this->block("formel","Formel",0,$this->fs,$we);		
      parent::ausgabe($ef);
  	   echo "</div>"; }}

class cl_ergebnis {
   public $hoehe,$breite;
   public function __construct($f) {
   global $WPF_EIG;
   	if(array_key_exists("sg",$WPF_EIG)) {
      	$this->hoehe=$f->hoehe*$WPF_EIG["sg"];
      	$this->breite=$f->breite*$WPF_EIG["sg"]; }
      else { $this->hoehe=$f->hoehe; $this->breite=$f->breite; }}}

function wpformel($ftx,$eig="",$zp=false,$zs=false) {
global $WPF_EIG;
   $n=func_num_args();
   if(($n==2||$n==3)&&is_bool($eig)) { $zs=$zp; $zp=$eig; $eig=""; } 
   wpeigenschaften($eig);
   if($zp||$zs) $WPF_EIG["tt"]=true; else $WPF_EIG["tt"]=false;
   if(array_key_exists("sg",$WPF_EIG)) $fs=$WPF_EIG["sg"]; else $fs=1;
   do { 
	   $ftz=wps_zeichen($ftx);
   	$fp=0; $stack=array();
   	$u=st_objekt("term",$ftz,$fp,$stack,Null);
   	$fb=new cl_formel($u);
   	$f=$fb->mass($fs); 
   	if($f<0) {
   		if(-$f<=1) break; // Schutz gegen Dauerschleife
   		$fs=-$f*$fs; }} 
   while($f<0);
   if($zp) {
      echo "<p><b>Parser:</b><br />\n";
      foreach($ftz as $fz) $fz->ausgabe();
      echo "<br /></p>"; }
   if($zs)  {
      echo "<div><b>Struktur:</b>";
      if($fs!=1) echo " (globaler Schriftfaktor=".$fs.")";
      echo "<br />\n";
      zeige($fb);
      echo "<br /></div>"; }
   if($zp||$zs) echo "\n\n\n";
   $fb->ausgabe();
   return new cl_ergebnis($fb); }
?>